Subject: Re: cvsimport/cvsps: wrong revisions in branch

From: Simon 'corecode' Schubert <[email-masked]>
Date: Thu, 25 Jan 2007 17:24:49 +0100

Uwe Kleine-König wrote:
> I don't know ruby nor hg, but I managed to clone your repo.  Now I'm
> stuck with:
> 
> 	zeisberg@cepheus:~/hsrc/fromcvs$ ruby1.8 fromcvs.rb 
> 	fromcvs.rb:1:in `require': no such file to load -- rcsfile (LoadError)
> 	        from fromcvs.rb:1

yes, you need the rcsparse module, available from the same address.

> Is there some documentation how to get that to work?

I've written it a million times to different people on irc, but somehow I never got around to making a README out of it.  I'll write it up very condensed here and add this as a base for a README to the the repo.

From CVS to * in little time
============================

Prerequisites:
  - ruby (1.8.5 known working)
  - fromcvs, <http://ww2.fs.ei.tum.de/~corecode/hg/fromcvs>
  - rcsparse, <http://ww2.fs.ei.tum.de/~corecode/hg/rcsparse> (ruby module)
  - Ruby/RBTree, <http://raa.ruby-lang.org/project/ruby-rbtree/>
  - for git: git-fast-import, <git://repo.or.cz/git/fastimport.git/>
  - for hg: ruby-python, <http://ww2.fs.ei.tum.de/~corecode/hg/ruby-python>

How to convert a CVS repo:

There is still a nice frontend missing, so you have to invoke the scripts by hand.

% mkdir gitdest && (cd gitdest && git init)
% ruby togit.rb /path/to/cvsroot modulename gitdest
% cd gitdest && git-repack -a -f -d      # optional, saves 20% or so

If you want to get nice author names, create setup the file authormap:

cat > /path/to/cvsroot/CVSROOT/authormap
corecode	Simon 'corecode' Schubert <[email-masked]>
jdoe		Jon H. Doe <[email-masked]>
branch-fixup	CVS repo conversion <[email-masked]>

that's about for the quickstart.  be sure to report conversion errors or runtime issues (possibly due to obscure CVS repo activity) to me.

cheers
  simon

-- 
Serve - BSD     +++  RENT this banner advert  +++    ASCII Ribbon   /"\
Work - Mac      +++  space for low €€€ NOW!1  +++      Campaign     \ /
Party Enjoy Relax   |   http://dragonflybsd.org      Against  HTML   \
Dude 2c 2 the max   !   http://golden-apple.biz       Mail + News   / \